//+------------------------------------------------------------------+
//|                                           SFI_MovingAverages.mq4 |
//|                                        Copyright  2012, N.Mexas |
//|                                        http://www.metaquotes.net |
//+------------------------------------------------------------------+
#property copyright "Copyright  2012, N.Mexas"

#property indicator_separate_window
#property indicator_buffers 3
#property indicator_color1 White
#property indicator_color2 Blue
#property indicator_color3 Red


#property indicator_level3 20
#property indicator_levelcolor White
#property indicator_levelwidth 1
#property indicator_levelstyle STYLE_DASH

//--- input parameters
extern int       ADX_Periods        =14;
extern int       MA_Method_1        =0;
extern int       MA_Method_2        =0;
extern int       MA_1_Periods       =9;
extern int       MA_2_Periods       =12;
extern int       Price_Apply        =0;
extern int       cbars              =0;

//--- buffers
double RSI[];
double MA_Input_1[];
double MA_Input_2[];
double TSF[];
double haClose[], haOpen[], haHigh[], haLow[];


//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
int init()
  {

  SetIndexStyle (0, DRAW_LINE,STYLE_DOT);
  SetIndexStyle (1, DRAW_LINE,0,1);
  SetIndexStyle (2, DRAW_LINE,0,1);
 
  SetIndexBuffer(0, RSI);
  SetIndexBuffer(1, MA_Input_1);
  SetIndexBuffer(2, MA_Input_2);
  string short_name; 
  string short_name1;  
   switch(MA_Method_1)
     {
      case 0  :short_name= "MA1:Simple Moving Average("; break; 
      case 1  :short_name= "MA1:Exponential Moving Average(";  break;
      case 2  :short_name= "MA1:Smoothed Moving Average(";  break;
      case 3  :short_name= "MA1:Linear Weigthed Moving Average(";  break;      
      case 4  :short_name= "MA1:Sine Weigthed Moving Average(";  break;
      case 5  :short_name= "MA1:Triangular Moving Average(";  break;
      case 6  :short_name= "MA1:Least Square Moving Average(";  break;
      case 7  :short_name= "MA1:Hull Moving Average by Alan Hull(";  break;
      case 8  :short_name= "MA1:Moving Median(";  break;
      case 9  :short_name= "MA1:Geometric Mean(";  break;
      case 10 :short_name= "MA1:Integral of Linear Regression Slope(";  break;
      case 11 :short_name= "MA1:Combination of LSMA and ILRS(";  break;
      case 12 :short_name= "MA1:Wilder Exponential Moving Average(";  break;
      case 13 :short_name= "MA1:Zero-Lag Exponential Moving Average(";  break;
      case 14 :short_name= "MA1:Time Series("; break;
      default :short_name= "MA1:DEFAULT IRSI(";  break;
     }
   switch(MA_Method_2)
     {
      case 0  :short_name1= " - MA2:Simple Moving Average("; break; 
      case 1  :short_name1= " - MA2:Exponential Moving Average(";  break;
      case 2  :short_name1= " - MA2:Smoothed Moving Average(";  break;
      case 3  :short_name1= " - MA2:Linear Weigthed Moving Average(";  break;      
      case 4  :short_name1= " - MA2:Sine Weigthed Moving Average(";  break;
      case 5  :short_name1= " - MA2:Triangular Moving Average(";  break;
      case 6  :short_name1= " - MA2:Least Square Moving Average(";  break;
      case 7  :short_name1= " - MA2:Hull Moving Average by Alan Hull(";  break;
      case 8  :short_name1= " - MA2:Moving Median(";  break;
      case 9  :short_name1= " - MA2:Geometric Mean(";  break;
      case 10 :short_name1= " - MA2:Integral of Linear Regression Slope(";  break;
      case 11 :short_name1= " - MA2:Combination of LSMA and ILRS(";  break;
      case 12 :short_name1= " - MA2:Wilder Exponential Moving Average(";  break;
      case 13 :short_name1= " - MA2:Zero-Lag Exponential Moving Average(";  break;
      case 14 :short_name1= " - MA2:Time Series("; break;
      default :short_name1= " - MA2:DEFAULT IRSI(";  break;
     }  
   IndicatorShortName(short_name+MA_1_Periods+")"+short_name1+MA_2_Periods+")")   ;
//---- indicators
//----
   return(0);
  }
//+------------------------------------------------------------------+
//| Custom indicator deinitialization function                       |
//+------------------------------------------------------------------+
int deinit()
  {
//----
   
//----
   return(0);
  }
//+------------------------------------------------------------------+
//| Custom indicator iteration function                              |
//+------------------------------------------------------------------+
int start() {
 
  int shift,limit = cbars;
  if(limit==0) limit = Bars;
  
      for(shift=limit-1; shift>=0; shift--) 
      {
         if(Bars == iBars(NULL,0)- 1) 
         {
         haClose[Bars] = iClose(NULL,0,Bars);
         haOpen[Bars]  = iOpen(NULL,0,Bars);
         haHigh[Bars]  = iHigh(NULL,0,Bars);
         haLow[Bars]   = iLow(NULL,0,Bars);
         }
         else
         {
         haOpen[Bars]  = (haOpen[Bars+1]+haClose[Bars+1])/2;
         haHigh[Bars]  = MathMax(iHigh(NULL,0,Bars),MathMax(haOpen[Bars], haClose[Bars]));
         haLow[Bars]   = MathMin(iLow(NULL,0,Bars),MathMin(haOpen[Bars], haClose[Bars]));
         }
      switch(Price_Apply)
      {
      case 0: RSI[shift] = iADX(NULL,0,ADX_Periods,PRICE_CLOSE,MODE_MAIN,shift); break;
      case 1: RSI[shift] = iADX(NULL,0,ADX_Periods,PRICE_OPEN,MODE_MAIN,shift); break;
      case 2: RSI[shift] = iADX(NULL,0,ADX_Periods,PRICE_HIGH,MODE_MAIN,shift); break;
      case 3: RSI[shift] = iADX(NULL,0,ADX_Periods,PRICE_LOW,MODE_MAIN,shift); break;
      case 4: RSI[shift] = iADX(NULL,0,ADX_Periods,PRICE_MEDIAN,MODE_MAIN,shift); break;
      case 5: RSI[shift] = iADX(NULL,0,ADX_Periods,PRICE_TYPICAL,MODE_MAIN,shift); break;
      case 6: RSI[shift] = iADX(NULL,0,ADX_Periods,PRICE_WEIGHTED,MODE_MAIN,shift); break;
      case 7: RSI[shift] = iADX(NULL,0,ADX_Periods,(iOpen(NULL,0,Bars)+iHigh(NULL,0,Bars)+iLow(NULL,0,Bars)+iClose(NULL,0,Bars))/4,MODE_MAIN,shift); break;
      case 8: RSI[shift] = iADX(NULL,0,ADX_Periods,haOpen[Bars],MODE_MAIN,shift); break;
      case 9: RSI[shift] = iADX(NULL,0,ADX_Periods,haHigh[Bars],MODE_MAIN,shift); break;
      case 10:RSI[shift] = iADX(NULL,0,ADX_Periods,haLow[Bars],MODE_MAIN,shift); break;
      default:RSI[shift] = iADX(NULL,0,ADX_Periods,PRICE_CLOSE,MODE_MAIN,shift); break;
      }
  }
  
  for(shift=limit-1; shift>=0; shift--) 
  {
     switch(MA_Method_1)
     {
      case 0  :MA_Input_1[shift] = iMAOnArray(RSI,0,MA_1_Periods,0,MODE_SMA,shift);  break;
      case 1  :MA_Input_1[shift] = iMAOnArray(RSI,0,MA_1_Periods,0,MODE_EMA,shift);  break;
      case 2  :MA_Input_1[shift] = iMAOnArray(RSI,0,MA_1_Periods,0,MODE_SMMA,shift);  break;
      case 3  :MA_Input_1[shift] = iMAOnArray(RSI,0,MA_1_Periods,0,MODE_LWMA,shift);  break;      
      case 4  :MA_Input_1[shift] = SineWMA(RSI,MA_1_Periods,shift);  break;
      case 5  :MA_Input_1[shift] = TriMA(RSI,MA_1_Periods,shift);  break;
      case 6  :MA_Input_1[shift] = LSMA(RSI,MA_1_Periods,shift);  break;
      case 7  :MA_Input_1[shift] = HMA(RSI,MA_1_Periods,shift);  break;
      case 8  :MA_Input_1[shift] = Median(RSI,MA_1_Periods,shift);  break;
      case 9  :MA_Input_1[shift] = GeoMean(RSI,MA_1_Periods,shift);  break;
      case 10 :MA_Input_1[shift] = ILRS(RSI,MA_1_Periods,shift);  break;
      case 11 :MA_Input_1[shift] = IE2(RSI,MA_1_Periods,shift);  break;
      case 12 :MA_Input_1[shift] = Wilder(RSI,RSI,MA_1_Periods,shift);  break;
      case 13 :MA_Input_1[shift] = ZeroLagEMA(RSI,RSI,MA_1_Periods,shift);  break;
      case 14 :MA_Input_1[shift] = TSF(RSI,MA_1_Periods,shift); break;
      default :MA_Input_1[shift] = iRSI(NULL,0,ADX_Periods,PRICE_CLOSE,shift);  break;
     }
     
     switch(MA_Method_2)
     {
      case 0  :MA_Input_2[shift] = iMAOnArray(MA_Input_1,0,MA_2_Periods,0,MODE_SMA,shift);  break;
      case 1  :MA_Input_2[shift] = iMAOnArray(MA_Input_1,0,MA_2_Periods,0,MODE_EMA,shift);  break;
      case 2  :MA_Input_2[shift] = iMAOnArray(MA_Input_1,0,MA_2_Periods,0,MODE_SMMA,shift);  break;
      case 3  :MA_Input_2[shift] = iMAOnArray(MA_Input_1,0,MA_2_Periods,0,MODE_LWMA,shift);  break;      
      case 4  :MA_Input_2[shift] = SineWMA(MA_Input_1,MA_2_Periods,shift);  break;
      case 5  :MA_Input_2[shift] = TriMA(MA_Input_1,MA_2_Periods,shift);  break;
      case 6  :MA_Input_2[shift] = LSMA(MA_Input_1,MA_2_Periods,shift);  break;
      case 7  :MA_Input_2[shift] = HMA(MA_Input_1,MA_2_Periods,shift);  break;
      case 8  :MA_Input_2[shift] = Median(MA_Input_1,MA_2_Periods,shift);  break;
      case 9  :MA_Input_2[shift] = GeoMean(MA_Input_1,MA_2_Periods,shift);  break;
      case 10 :MA_Input_2[shift] = ILRS(MA_Input_1,MA_2_Periods,shift);  break;
      case 11 :MA_Input_2[shift] = IE2(MA_Input_1,MA_2_Periods,shift);  break;
      case 12 :MA_Input_2[shift] = Wilder(MA_Input_1,MA_Input_1,MA_2_Periods,shift);  break;
      case 13 :MA_Input_2[shift] = ZeroLagEMA(MA_Input_1,MA_Input_1,MA_2_Periods,shift);  break;
      case 14 :MA_Input_2[shift] = TSF(MA_Input_1,MA_2_Periods,shift); break;
      default :MA_Input_2[shift] = iRSI(NULL,0,ADX_Periods,PRICE_CLOSE,shift);  break;
     }
}
//---- done
   return(0);
      
}
//+------------------------------------------------------------------+

double TSF (double array[],int per,int bar)//(double array[])
{
   double Sum=0;
   for(int i=per; i>=1; i--) 
        Sum += (i-(per+1)/3.0)*array[bar-per+i];
   double lsma = Sum*6/(per*(per+1));
   return(lsma);
}

double SMA(double array[],int per,int bar)
{
   double Sum = 0;
   for(int i = 0;i <= per;i++) Sum += array[bar-i];
   return(Sum/per);
}
double Wilder(double array1[],double array2[],int per,int bar)
{
   if(bar == per) double wilder = SMA(array1,per,bar);
   else 
   if(bar > per) wilder = array2[bar-1] + (array1[bar] - array2[bar-1])/per; 
   
   return(wilder);
}
double LWMA(double array[],int per,int bar)
{
   double Sum = 0;
   double Weight = 0;
   
      for(int i = 0;i < per;i++)
      { 
      Weight+= (per - i);
      Sum += array[bar-i]*(per - i);
      }
   if(Weight>0) double lwma = Sum/Weight;
   else lwma = 0; 
   return(lwma);
}  
double SineWMA(double array[],int per,int bar)
{
   double pi = 3.1415926535;
   double Sum = 0;
   double Weight = 0;
  
      for(int i = 0;i < per-1;i++)
      { 
      Weight+= MathSin(pi*(i+1)/(per+1));
      Sum += array[bar-i]*MathSin(pi*(i+1)/(per+1)); 
      }
   if(Weight>0) double swma = Sum/Weight;
   else swma = 0; 
   return(swma);
}
double TriMA(double array[],int per,int bar)
{
   double sma;
   int len = MathCeil((per+1)*0.5);
   
   double sum=0;
   for(int i = 0;i < len;i++) 
   {
   sma = SMA(array,len,bar-i);
   sum += sma;
   } 
   double trima = sum/len;
   
   return(trima);
}
double LSMA(double array[],int per,int bar)
{   
   double Sum=0;
   for(int i=per; i>=1; i--) Sum += (i-(per+1)/3.0)*array[bar-per+i];
   double lsma = Sum*6/(per*(per+1));
   return(lsma);
}

           

double HMA(double array[],int per,int bar)
{
   double tmp[];
   int len =  MathSqrt(per);
   ArrayResize(tmp,len);
   
   if(bar == per) double hma = array[bar]; 
   else
   if(bar > per)
   {
   for(int i = 0; i < len;i++) tmp[len-i-1] = 2*LWMA(array,per/2,bar-i) - LWMA(array,per,bar-i);  
   hma = LWMA(tmp,len,len-1); 
   }  

   return(hma);
}
double ZeroLagEMA(double array1[],double array2[],int per,int bar)
{
   double alfa = 2.0/(1+per); 
   int lag = 0.5*(per - 1); 
   
   if(bar == lag) double zema = array1[bar];
   else 
   if(bar > lag) zema = alfa*(2*array1[bar] - array1[bar-lag]) + (1-alfa)*array2[bar-1];
   
   return(zema);
}
double Median(double price[],int per,int bar)
{
   double array[];
   ArrayResize(array,per);
   
   for(int i = 0; i < per;i++) array[i] = price[bar-i];
   ArraySort(array);
   
   int num = MathRound((per-1)/2); 
   if(MathMod(per,2)>0) double median = array[num]; else median = 0.5*(array[num]+array[num+1]);
   
   return(median); 
}
double GeoMean(double price[],int per,int bar)
{
   double gmean = MathPow(price[bar],1.0/per); 
   for(int i = 1; i < per;i++) gmean *= MathPow(price[bar-i],1.0/per); 
   
   return(gmean);
}
double ILRS(double price[],int per,int bar)
{
   double sum = per*(per-1)*0.5;
   double sum2 = (per-1)*per*(2*per-1)/6.0;
     
   double sum1 = 0;
   double sumy = 0;
      for(int i=0;i<per;i++)
      { 
      sum1 += i*price[bar-i];
      sumy += price[bar-i];
      }
   double num1 = per*sum1 - sum*sumy;
   double num2 = sum*sum - per*sum2;
   
   if(num2 != 0) double slope = num1/num2; else slope = 0; 
   double ilrs = slope + SMA(price,per,bar);
   
   return(ilrs);
}

double IE2(double price[],int per,int bar)
{
   double ie = 0.5*(ILRS(price,per,bar) + LSMA(price,per,bar));
      
   return(ie); 
}